package com.zhongzheng.modules.exam.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;
import com.zhongzheng.modules.exam.bo.ExamArrangementGuideAddBo;
import com.zhongzheng.modules.exam.bo.ExamArrangementGuideQueryBo;
import com.zhongzheng.modules.exam.bo.ExamArrangementGuideEditBo;
import com.zhongzheng.modules.exam.domain.ExamArrangementGuide;
import com.zhongzheng.modules.exam.mapper.ExamArrangementGuideMapper;
import com.zhongzheng.modules.exam.vo.ExamArrangementGuideVo;
import com.zhongzheng.modules.exam.service.IExamArrangementGuideService;
import org.springframework.transaction.annotation.Transactional;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 【请填写功能名称】Service业务层处理
 *
 * @author change
 * @date 2021-06-08
 */
@Service
public class ExamArrangementGuideServiceImpl extends ServiceImpl<ExamArrangementGuideMapper, ExamArrangementGuide> implements IExamArrangementGuideService {

    @Override
    public ExamArrangementGuideVo queryById(Long id){
        ExamArrangementGuide db = this.baseMapper.selectById(id);
        return BeanUtil.toBean(db, ExamArrangementGuideVo.class);
    }

    @Override
    public List<ExamArrangementGuideVo> queryList(ExamArrangementGuideQueryBo bo) {
        LambdaQueryWrapper<ExamArrangementGuide> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getExamTypeId() != null, ExamArrangementGuide::getExamTypeId, bo.getExamTypeId());
        lqw.eq(StrUtil.isNotBlank(bo.getExamType()), ExamArrangementGuide::getExamType, bo.getExamType());
        lqw.eq(bo.getTypeNum() != null, ExamArrangementGuide::getTypeNum, bo.getTypeNum());
        lqw.eq(StrUtil.isNotBlank(bo.getTypeText()), ExamArrangementGuide::getTypeText, bo.getTypeText());
        lqw.eq(bo.getStatus() != null, ExamArrangementGuide::getStatus, bo.getStatus());
        lqw.notIn(bo.getStatus() == null, ExamArrangementGuide::getStatus, 0);
        lqw.orderByDesc(ExamArrangementGuide::getUpdateTime);
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<ExamArrangementGuideVo> entity2Vo(Collection<ExamArrangementGuide> collection) {
        List<ExamArrangementGuideVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, ExamArrangementGuideVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<ExamArrangementGuide> page = (Page<ExamArrangementGuide>)collection;
            Page<ExamArrangementGuideVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public Boolean insertByAddBo(ExamArrangementGuideAddBo bo) {
        ExamArrangementGuide add = BeanUtil.toBean(bo, ExamArrangementGuide.class);
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        if (bo.getStatus() == 1){
            add.setIssueTime(DateUtils.getNowTime());
        }
        return this.save(add);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public Boolean updateByEditBo(ExamArrangementGuideEditBo bo) {
        ExamArrangementGuide update = BeanUtil.toBean(bo, ExamArrangementGuide.class);
        //validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(ExamArrangementGuide entity){
        //TODO 做一些数据校验,如唯一约束
        LambdaQueryWrapper<ExamArrangementGuide> lqw = Wrappers.lambdaQuery();
        lqw.eq(entity.getExamTypeId() != null, ExamArrangementGuide::getExamTypeId, entity.getExamTypeId());
        if (this.list(lqw).size() > 0){
            throw new RuntimeException("关联考试类型重复，已有此考试类型");
        }
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }

    @Override
    public List<ExamArrangementGuideVo> queryArrangementGuideQueryList(ExamArrangementGuideQueryBo bo) {
        return null;
    }
}
